package org.uclic.algebra;

import org.jdom.Element;
import org.uclic.algebra.EvaluationException;
import org.uclic.algebra.EventAlgebra;
import org.uclic.algebra.Term;

/**
 * Term wrapper for int.
 *
 * @version 0.4
 * @author Jeremy Gow
 */
public class IntTerm extends Term {
   
    private int value;

    public IntTerm(int i, EventAlgebra a) {
	super(a);
	value = i;
    }

    public IntTerm(EventAlgebra a) {
	this(1, a);
    }

    public int value() {
	return value;
    }

    public int termType() {
	return TEXT_TYPE;
    }

    public String[] terms() {
	return null;
    }

    public Term buildTerm(int i) {
	return new IntTerm(i, algebra);
    }

    public int length() {
	return 0;
    }

    public String toString() {
	return Integer.toString(value);
    }

    public String termString() {
	return Integer.toString(value);
    }

    public Element toXML() {
	return null;
    }

    public String elementName() {
	return null;
    }

    public Term copyTerm(EventAlgebra a) {
	return new IntTerm(value, a);
    }
}
