package org.uclic.algebra;

import java.io.*;
import java.util.Date;
import java.util.Iterator;
import java.util.ListIterator;
import java.util.Vector;
import org.uclic.matrix.Matrix;
import org.uclic.matrix.WrongSize;
import org.uclic.algebra.*;
import org.uclic.algebra.event.*;
import org.uclic.algebra.property.*;
import org.uclic.util.ArrayUtils;

/**
 * Generates properties for an event algebra.
 *
 * @author Jeremy Gow
 * @version 0.4
 */
public class PropertyGenerator {

    private EventAlgebra        algebra;
    //private EquivClassGenerator ecGenerator;
    private Vector              properties;
    private int[]               partial1, partial2;

    private int maxSize;
    private int minPartial;
    
    public PropertyGenerator(EventAlgebra alg, int s, int p, GeneratorLog log) {
	algebra = alg;
	maxSize = s;
	minPartial = p;
	//ecGenerator = new EquivClassGenerator(alg, max);
    }

    public Vector properties() {
	return properties;
    }

    public void generate() {
	
	properties = new Vector();
	
	/*
	Date date;

	date = new Date();
	System.out.println("Start: " + date.toString());
	
	ecGenerator.generate();
	
	date = new Date();
	System.out.println("Equiv classes generated: " + date.toString());

	properties = new Vector();
	addProperties();
	
	date = new Date();
	System.out.println("Properties generated: " + date.toString());

	addPartialProperties();

	date = new Date();
	System.out.println("Partial properties generated: " + date.toString());
	*/
	//printProperties();
    }

    /*
    private void printProperties() {

	Iterator itr = properties.iterator();
	PropertyTerm p;

	try {
	    FileWriter writer = new FileWriter("/home/jeremy/maui/properties.txt");
	    writer.write("Properties: " + properties.size() + "\n");            
	    while (itr.hasNext()) {
		p = (PropertyTerm) itr.next();
		writer.write(p.toString() + "\n");
	    }
            writer.close();
	    
        } catch (IOException e) {
            e.printStackTrace();
	}
    }

    private void addPartialProperties() {
	
	int c = ecGenerator.classes();
	int percent;
	Matrix mi, mj;
	EventTerm ei, ej;
	partial1 = null;
	partial2 = null;

	for (int i = 0; i < c; i++) {
	    for (int j = 0; j < i; j++) {
		if (i != j) {
		    mi = ecGenerator.getMatrix(i);
		    mj = ecGenerator.getMatrix(j);
		    percent = ArrayUtils.percent(mi.equalRows(mj));

		    if (!(percent < PARTIAL)) {
			ei = ecGenerator.getEquivClass(i)[0];
			ej = ecGenerator.getEquivClass(j)[0];
			addProperty(new EqualEvents(ei, ej, algebra));
		    }
		}
	    }
	}
    }

    private void addProperties() {

	EventTerm[] cls, cls2;
	EventTerm rep, expr;
	int c = ecGenerator.classes();

	for (int i = 0; i < c; i++) {

	    cls = ecGenerator.getEquivClass(i);
	    	    
	    for (int j = 1; j < cls.length; j++) {
		addProperty(new EqualEvents(cls[0], cls[j], algebra));
	    }

	    if (partial1 != null) { 
	    
		for (int p = 0; p < partial1.length; p++) {
		    
		    if (partial1[p] == c) {
		   
			cls2 = ecGenerator.getEquivClass(partial2[p]);
			addProperty(new EqualEvents(cls[0], cls2[0], algebra));
		    }
		}
	    }
	}
    }

    private void addProperty(PropertyTerm prop) {

	ListIterator itr = properties.listIterator();
	PropertyTerm p;
	int l = prop.length();
	boolean added = false;	

	while (itr.hasNext()) {

	    p = (PropertyTerm) itr.next();
	    if (l < p.length()) {
		itr.previous();
		itr.add(prop);
		added = true;
		break;
	    }
	}

	if (!added) {
	    properties.add(prop);
	}
    }
    */
}
