package org.uclic.algebra.event;

import java.util.NoSuchElementException;
import org.jdom.Element;
import org.uclic.algebra.EvaluationException;
import org.uclic.algebra.EventAlgebra;
import org.uclic.algebra.Term;

/**
 * An individual event in an event algebra.
 *
 * @version 0.4
 * @author Jeremy Gow
 */
public abstract class AtomicEvent extends EventTerm {
   
    public AtomicEvent(EventAlgebra a) {
	super(a);
    }

    public int events() {
	return 1;
    }

    public int length() {
	return 1;
    }

    /*
    public EventTerm normalProduct(AtomicEvent e) {

	EventTerm norm;

	if (equals(e)) {
	    norm = (EventTerm) new Power(this, 2, algebra);

	} else {
	    EventTerm[] events = new EventTerm[2];
	    events[0] = this;
	    events[1] = e;
	    norm = (EventTerm) new EventProduct(events, algebra);
	}

	return norm;
    }
    */

    public EventTerm normalProduct(AtomicEvent e) {
	return new UIEvent(algebra);
    }
    
    public EventIterator eventIterator() {
	return new AtomicEventIterator(this);
    }

    class AtomicEventIterator implements EventIterator {

	private AtomicEvent atom;
	private boolean     next;
	
	public AtomicEventIterator (AtomicEvent ae) {
	    atom = ae;
	    next = true;
	}
	
	public boolean hasNext() {
	    return next;
	}
	
	public AtomicEvent next() {
	    if (next) {
		next = false;
		return atom;
	    } else {
		throw new NoSuchElementException();
	    }
	}
    }
}

