package org.uclic.algebra.event;

import java.util.List;
import org.jdom.Element;
import org.uclic.fui.*;
import org.uclic.algebra.*;
import org.uclic.matrix.Matrix;


/**
 * The identity element for an event algebra.
 *
 * @version 0.3
 * @author Jeremy Gow
 */
public class Id extends AtomicEvent {
   
    public final static String STRING  = "[Nothing]";

    public Id(EventAlgebra a) {
	super(a);
    }

    public Matrix evaluate() {
	return algebra.identityMatrix();
    }

    public String toString() {
	return STRING;
    }

    public String termString() {
	return STRING;
    }

    public String elementName() {
	return FUI_XML.ID_ELEM;
    }

    public Term copyTerm(EventAlgebra a) {
	return new Id(a);
    }
}

