package org.uclic.algebra.property;

import java.util.List;
import org.jdom.Element;
import org.uclic.fui.*;
import org.uclic.algebra.*;
import org.uclic.algebra.state.*;
import org.uclic.algebra.event.*;
import org.uclic.matrix.*;

/**
 * The equality of two event algebra elements.
 *
 * @version 0.3
 * @author Jeremy Gow
 */
public abstract class Equality extends PropertyTerm {
    
    public static final String IN_STRING   = " = ";

    public Equality(Term e1, Term e2, EventAlgebra a) {
	super(a);
	add(e1);
	add(e2);
    }

    public String termString() {
	return getSubterm(0).termString() + IN_STRING + getSubterm(1).termString();
    }

    protected String elementName() {
	return FUI_XML.EQUALS_ELEM;
    }

}

