package org.uclic.algebra.property;

import java.util.List;
import org.jdom.Element;
import org.uclic.algebra.*;
import org.uclic.algebra.event.*;

/**
 * The equality of two events.
 *
 * @version 0.3.2
 * @author Jeremy Gow
 */
public class EventEquality extends Equality {
    
    public static final String NODE_STRING = "Equals (events)";

    public EventEquality(EventTerm e1, EventTerm e2, EventAlgebra a) {
	super(e1, e2, a);
    }

    public EventEquality(EventAlgebra a) {
	super(new UIEvent(a), new UIEvent(a), a);
    }

    public boolean[] evaluate() throws EvaluationException {
	
	EventTerm lhs = (EventTerm) getSubterm(0);
	EventTerm rhs = (EventTerm) getSubterm(1);

	return lhs.evaluate().equalRows(rhs.evaluate());
    }

    public String toString() {
	return NODE_STRING;
    }

    public Term copyTerm(EventAlgebra a) {

	EventTerm lhs = (EventTerm) getSubterm(0);
	EventTerm rhs = (EventTerm) getSubterm(1);
	EventTerm e1 = (EventTerm) lhs.copyTerm(a);
	EventTerm e2 = (EventTerm) rhs.copyTerm(a);
       	return new EventEquality(e1, e2, a);
    }
}

