package org.uclic.algebra.property;

import org.jdom.Element;
import org.uclic.algebra.*;

/*
 * A term representing an event algebra property.
 *
 * @author Jeremy Gow
 * @version 0.3.2
 */
public abstract class PropertyTerm extends Term {

    public PropertyTerm(EventAlgebra a) {
	super(a);
    }

    /**
     * The row vector for this state.
     * @return A row vector.
     */
    public abstract boolean[] evaluate() throws EvaluationException;
	
    public String[] terms() {
	
	String[] terms = new String[4];

	terms[0] = EventEquality.NODE_STRING;
	terms[1] = StateEquality.NODE_STRING;
	terms[2] = Undo.NODE_STRING;
	terms[3] = Not.NODE_STRING;

	return terms;
    }
    
    public Term buildTerm(int i) {
		
	switch (i) {
	
	default:
	    return new EventEquality(algebra);

	case 1:
	    return new StateEquality(algebra);
	    
	case 2:
	    return new Undo(algebra);
	
	case 3:
	    return new Not(algebra);
	}
    }

}
