package org.uclic.fui;

import java.util.*;
import org.jdom.Element;

/**
 * XML writer for an interface model.
 *
 * @version 0.4
 */
public class DotWriter {

    private FUIDesign    design;
    private FUIModel     model;
    private StringBuffer dot;

    private final static String INIT_DOT = "digraph G {\nsize=\"7.5,10\"\noverlap=scale\nconcentrate=true\n";

    public DotWriter(FUIDesign d) {
	design = d;
	model = design.model();
    }

    public String write() {
	
	dot = new StringBuffer(INIT_DOT);
	
	for (int s = 0; s < model.states().length; s++) {
	    dot.append(model.state(s));
	    dot.append("[color=black];\n");
	}

	for (int s = 0; s < model.states().length; s++) {
	    for (int e = 0; e < model.states().length; e++) {
		int[] to = model.transitions(s, e);

		for (int i = 0; i < to.length; i++) {
		    dot.append(model.state(s));
		    dot.append(" -> ");
		    dot.append(model.state(to[i]));
		    dot.append("[label=\"");
		    dot.append(model.event(e));
		    dot.append("\"]");
		}
	    }
	}

	dot.append("}\n");

	return dot.toString();	
    }

}
