package org.uclic.matrix;

/**
 * A matrix with a single row.
 *
 * @author Jeremy Gow
 * @version 0.3
 */
public class RowVector extends Matrix {

    public RowVector(int c) {
	super(1, c);
    }

    public RowVector transform(Matrix matrix) throws WrongSize {
	RowVector product = new RowVector(matrix.cols());
	multiply(matrix, product);
	return product;
    }

    public RowVector multiplyVector(int constant) {
	RowVector multiple = new RowVector(cols());
	multiply(constant, multiple);
	return multiple;
    }

    public RowVector addVector(Matrix matrix) throws WrongSize {
	RowVector product = new RowVector(matrix.cols());
	multiply(matrix, product);
	return product;
    }

    public int getEntry(int col) throws OutsideMatrix {
	return getEntry(0, col);
    }    

    public void setEntry(int col, int val) throws OutsideMatrix {
	setEntry(0, col, val);
    }    

}
