package org.uclic.maui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


/**
 * A window in the MAUI system.
 *
 * @author Jeremy Gow
 * @version 0.4
 */
public abstract class MAUIFrame extends JFrame {
    
    private static String home;
    private static Image  icon;
    private final static int XDIM = 500;
    private final static int YDIM = 500;

    public MAUIFrame(String title, Image icon) {
	super(title);
	setIconImage(icon);
	
	// Add listeners
        addKeyListener(new MAUIKeys());
        addWindowListener(new MAUIWindow());

	// Set size & position
	Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
	int xind = (int) (screen.width - xDim())/2;
	int yind = (int) (screen.height - yDim())/2;
	setBounds(xind, yind, xDim(), yDim());
    }


    private class MAUIKeys extends KeyAdapter implements KeyListener {
	/* Ctrl + Q = Quit
	 */
	public void keyPressed(KeyEvent e) {
	    if (e.isControlDown() && e.getKeyCode() == KeyEvent.VK_Q) {
		exit();
	    }
	}
    }

    private class MAUIWindow extends WindowAdapter implements WindowListener {
	/* Exit when window is closed.
	 */
	public void windowClosing(WindowEvent e) {
	    exit();
	}
    }

    public abstract int xDim();
    public abstract int yDim();
    public abstract void exit();

}
