package org.uclic.maui;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Properties;
import java.util.Vector;
import javax.swing.*;
import org.jdom.JDOMException;

/**
 * The main menu bar for the MAUI application.
 *
 * @author Jeremy Gow
 * @version 0.4
 */
public class MAUIToolBar extends JToolBar {

    private MAUI maui;
 
    public final static String OPEN = "Open24.gif";
    public final static String NEW  = "New24.gif";
    public final static String SAVE = "Save24.gif";
    public final static String HELP = "Help24.gif";
    public final static String ABOUT = "About24.gif";

    public MAUIToolBar(MAUI m, JTextField title, JComboBox initial, JTable table1, JTable table2) {
	super();
	maui = m;
	setFloatable(false);
        setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
	FileOperator op = maui.operator();
	
	buildButton(MAUIMenu.OPEN_FILE, OPEN, op);
	buildButton(MAUIMenu.NEW_DESIGN, NEW, maui);
	buildButton(MAUIMenu.SAVE_FILE, SAVE, op);
	addSeparator();
	add(new JLabel(MAUI.MODEL_TITLE));
	add(title);
	addSeparator();
	add(new JLabel(MAUI.INIT_TITLE));
	add(initial);
	add(Box.createRigidArea(new Dimension(20, 0)));
	add(table1);
	add(table2);

	add(Box.createHorizontalGlue());
	addSeparator();
	buildButton(MAUIMenu.MAUI_HELP, HELP, maui);
	//buildButton(MAUIMenu.ABOUT_MAUI, ABOUT, maui);
    }
 
    private void buildButton(String name, String file, ActionListener listener) {
	ImageIcon icon = new ImageIcon(maui.iconPath(file)); 
	JButton btn = new JButton(icon);
	btn.setActionCommand(name);
        btn.addActionListener(listener);
	btn.setToolTipText(name);
	add(btn);
    }

}
