package org.uclic.maui;

import java.awt.*;
import java.awt.event.*;
import java.beans.PropertyVetoException;
import java.io.*;
import java.util.Observer;
import java.util.Observable;
import javax.swing.*;
import org.jdom.*;
import org.jdom.output.*;
import org.uclic.fui.*;
import org.uclic.maui.*;

/**
 * Displays XML description of interface model.
 *
 * @author Jeremy Gow
 * @version 0.4
 */
public class XMLFrame extends MAUITab {

    private final static String TITLE = "XML";
    private final static String ICON  = "Export24.gif";
    private final static String TIP   = "View an XML representation\nof the interface";

    private JTextArea fText;
    private JScrollPane fScroller;


    public XMLFrame(MAUI m) {
	super(TITLE, m, ICON, TIP);

	setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

	// Add scrolling text area
	fText = new JTextArea(20,30);
	fText.setEditable(false);
	fScroller = new JScrollPane(fText);
	fScroller.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	add(fScroller);

	displayXML();
    }
    
    public void rebuildTab() {
	displayXML();
    }

    private void displayXML() {

	FUIWriter fw = new FUIWriter(maui.design());
	Element elem = fw.write();

	XMLOutputter xo = new XMLOutputter();
	xo.setFormat(Format.getPrettyFormat());
	ByteArrayOutputStream o = new ByteArrayOutputStream();
	String str = "";
	try {
	    xo.output(elem, o);
	    str = o.toString();
	    o.close();
	} catch (IOException e) {}
	fText.setText(str);
    }
    
}
