package org.uclic.maui.edit;

import javax.swing.JPanel;
import org.uclic.fui.FUIException;
import org.uclic.fui.FUI_XML;
import org.uclic.util.ArrayUtils;

/**
 * @author Jeremy Gow
 * @version 0.4
 */
public class RangePanel extends ListPanel {

    private StateTrans  stateReln;
    private SuperTrans  superReln;

    public RangePanel(JPanel panel, Editor ed) {
	super(Editor.RANGE, panel, ed);
	stateReln = new StateTrans();
	superReln = new SuperTrans();
    }

    public void addItem(int i) throws FUIException {
	statePanel().addItem(i);
    }
    
    public void deleteItem(int i) {
	statePanel().deleteItem(i);
    }
    
    public void renameItem(int i, String name) throws FUIException {
	statePanel().renameItem(i, name);
    }
    
    public String[] items() {
	return statePanel().items();
    }
    
    public String getItemType() {
	return Editor.RANGE_LABEL;
    }

    public void populateList() {
	statePanel().populateList();
    }

    protected void highlightRelated() {

	if (editor.isTransSelected()) {
	    // Highlight states and superstates domains
	    eventPanel().highlightStateDomain();	
	    eventPanel().highlightSuperDomain();

	} else if (statePanel().isSelected()) {
	    // Highlight events between state domain and range
	    statePanel().highlightEvents();		    

	} else if (superPanel().isSelected()) {
	    // Highlight events between superstate domain and range
	    superPanel().highlightEvents();
	}
    }

    public void editModel() {
	if (statePanel().isSelected()) {
	    editModel(statePanel(), eventPanel(), stateReln);

	} else if (superPanel().isSelected()) {
	    editModel(superPanel(), eventPanel(), superReln);
	}
    }


    private class StateTrans implements TertiaryRelation {

	public int[] map(int i, int j, boolean ignore) {
	    return null;
	}

	public void toggle(int range, int state, int event) {
	    model().toggleTransition(state, event, range);
	}
    }

    private class SuperTrans implements TertiaryRelation {

	public int[] map(int i, int j, boolean ignore) {
	    return null;
	}
    	
	public void toggle(int range, int superstate, int event) {
	    model().toggleSuperTransition(superstate, event, range);
	}
    }
}
