package org.uclic.maui.edit;

import javax.swing.JPanel;
import org.uclic.fui.FUIException;
import org.uclic.fui.FUI_XML;
import org.uclic.util.ArrayUtils;

/**
 * @author Jeremy Gow
 * @version 0.4
 */
public class SignsPanel extends ListPanel {

    private StateSigns stateReln;
    private SuperSigns superReln;

    public SignsPanel(JPanel p, Editor ed) {
	super(Editor.SIGNS, p, ed);
	stateReln = new StateSigns();
	superReln = new SuperSigns();
    }

    public void addItem(int i) throws FUIException {
	model().addSign(FUI_XML.SIGN_ELEM + i);
    }

    public void deleteItem(int i) {
	design().deleteSign(i);
    }

    public void renameItem(int i, String name) throws FUIException {
	model().renameSign(i, name);
    }

    public String[] items() {
	return model().signs();
    }

    public String getItemType() {
	return Editor.SIGN_LABEL;
    }

    protected void highlightRelated() {
	    
	highlightList(statePanel().list, stateReln);
	highlightList(superPanel().list, superReln);
    }

    public void editModel() {
	
	if (superPanel().isSelected()) {
	    editModel(superPanel(), superReln);

	} else if (statePanel().isSelected()) {
	    editModel(statePanel(), stateReln);
	}
    }

    private class StateSigns implements BinaryRelation {

	public boolean[] map(int sign) {
	    return model().signifiedStates(sign);
	}

	public void toggle(int sign, int state) {
	    model().toggleStateSign(state, sign);
	}
    }
	
    private class SuperSigns implements BinaryRelation {

	public boolean[] map(int sign) {
	    return model().signifiedSuperstates(sign);
	}

	public void toggle(int sign, int superstate) {
	    model().toggleSuperstateSign(superstate, sign);
	}
    }
}
