package org.uclic.maui.stats;

import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import org.uclic.maui.*;

/**
 * Provides statistics about the interface model.
 *
 * @author Jeremy Gow
 * @version 0.4
 *
 * Quick report:
 * number states, events, classes, signs, trans
 *
 * Detailed report on request:
 * min, max, avg path len between 2 states
 * error recovery
 *
 */
public class Statistics extends MAUITab {

    private JTextArea text;

    private final static String TITLE = "Overview";
    private final static String ICON  = "Information24.gif";
    private final static String TIP   = "An overview of the interface";

    public Statistics (MAUI a){
	super(TITLE, a, ICON, TIP);
	build();
    }

    public void rebuildTab() {
	removeAll();
	build();
    }

    private void build() {

	Integer s = new Integer(model().states().length);
	Integer e = new Integer(model().events().length);
	Integer p = new Integer(model().superstates().length);
	Integer g = new Integer(model().signs().length);

	Object[][] data = {
	    {"States", s}, 
	    {"Events", e},
	    {"Superstates", p}, 
	    {"Signs", g}
	};

	Object[] names = {"", ""};

	JTable table = new JTable(data, names);
	table.setCellSelectionEnabled(false);
	
	//table.setRowHeight(30);

	TableColumnModel m = table.getColumnModel();
	//m.getColumn(0).setPreferredWidth(100);
	m.getColumn(1).setPreferredWidth(30);

	add(table);
    }    

}
